# M_CLI2.f90 and associated files
![M_CLI2](docs/images/M_CLI2.gif)
## Name
### M_CLI2 - parse Unix-like command line arguments from Fortran

## Description
   M_CLI2(3f) is a Fortran module that will crack the command line when
   given a prototype string that looks very much like an invocation of
   the program. calls are then made for each parameter name to set the
   variables appropriately in the program.

## Example Program
This short program defines a command that can be called using
conventional Unix-style syntax for short and long parameters:

```bash
   ./show -x 10 -y -20 -p 10,20,30 --title "plot of stuff" -L
   ./show -lL
   ./show  --title="my new title" 
   ./show  -T "my new title" 
```
```fortran
   program show
   use M_CLI2, only : set_args, get_args, sget, igets, set_mode
   implicit none
   real                          :: x,y,z
   logical                       :: l, lbig
   integer,allocatable           :: p(:)
   character(len=:),allocatable  :: title
   namelist /args/x,y,z,l,lbig,p,title ! just for printing
      call set_mode('strict')
      !
      ! Define command and default values and parse supplied command line options
      call set_args('-x 1 -y 2.0 -z 3.5e0 -p 11,-22,33 --title:T "my title" -l F -L F')
      !
      ! multiple scalar non-allocatable values can be done in one call if desired
      call get_args('x',x,'y',y,'z',z,'l',l,'L',lbig)

      ! you can use convenience functions for allocatable arrays and strings.
      ! The functions are particularly useful in expressions and as arguments on
      ! procedure calls
      title=sget('title') ! string 
      p=igets('p') ! integer array
      !
      ! All ready to go, print it as a namelist so everything is labeled
      write(*,args)
   end program show
```
running with no options shows the defaults
```text
&ARGS
 X=  1.00000000    ,
 Y=  2.00000000    ,
 Z=  3.50000000    ,
 L=F,
 LBIG=F,
 P=11         ,-22        ,33         ,
 TITLE="my title",
 /
```
An arbitrary number of strings such as filenames may be passed in on
the end of commands; you can query whether an option was supplied; and
get_args(3f)-related routines can be used for refining options such as
requiring lists of a specified size.

These parameters are defined automatically
```bash
    --help
    --usage
    --version
```
You must supply text for the optional "--help" and "--version" keywords, as
described under SET_ARGS(3f).

![docs](docs/images/docs.gif)
## Documentation

![manpages](docs/images/manpages.gif)
### man-pages 
- HTML [man-pages](https://urbanjost.github.io/M_CLI2/man3.html) index of individual procedures
- HTML [book-form ](https://urbanjost.github.io/M_CLI2/BOOK_M_CLI2.html) of pages consolidated using JavaScript
+ [manpages.zip](https://urbanjost.github.io/M_CLI2/manpages.zip) for installing wherever the man(1) command is available
+ [manpages.tgz](https://urbanjost.github.io/M_CLI2/manpages.tgz) is an alternative tar(1) format archive

### developer documentation
- [doxygen(1) output](https://urbanjost.github.io/M_CLI2/doxygen_out/html/index.html).
- [ford(1) output](https://urbanjost.github.io/M_CLI2/fpm-ford/index.html).

### logs
- [CHANGELOG](docs/CHANGELOG.md)
- [STATUS](docs/STATUS.md) of most recent CI/CD runs

![gmake](docs/images/gnu.gif)
## Download and Build with Make(1)
   Compile the M_CLI2 module and build all the example programs.
```bash
   git clone https://github.com/urbanjost/M_CLI2.git
   cd M_CLI2/src
   # change Makefile if not using one of the listed compilers

   # for gfortran
   make clean
   make gfortran

   # for ifort
   make clean
   make ifort

   # for nvfortran
   make clean
   make nvfortran

   # display other options (test, run, doxygen, ford, ...)
   make help
```
   To install you then generally copy the *.mod file and *.a file to
   an appropriate directory.  Unfortunately, the specifics vary but in
   general if you have a directory $HOME/.local/lib and copy those files
   there then you can generally enter something like
```bash
     gfortran -L$HOME/.local/lib -lM_CLI2  myprogram.f90 -o myprogram
```
   There are different methods for adding the directory to your default
   load path, but frequently you can append the directory you have
   placed the files in into the colon-separated list of directories
   in the $LD_LIBRARY_PATH or $LIBRARY_PATH environment variable, and
   then the -L option will not be required (or it's equivalent in your
   programming environment).
```bash
       export LD_LIBRARY_PATH=$HOME/.local/lib:$LD_LIBRARY_PATH
```
   **NOTE**: If you use multiple Fortran compilers you may need to create
   a different directory for each compiler. I would recommend it, such
   as $HOME/.local/lib/gfortran/.

### Creating a shared library

   If you desire a shared library as well, for gfortran you may enter
```bash
     make clean gfortran gfortran_install
```
   and everything needed by gfortran will be placed in libgfortran/ that
   you may add to an appropriate area, such as $HOME/.local/lib/gfortran/.
```bash
     make clean ifort ifort_install # same for ifort
```
   does the same for the ifort compiler and places the output in libifort/.
### Specifics may vary

   NOTE: The build instructions above are specific to a ULS (Unix-Like
   System) and may differ, especially for those wishing to generate shared
   libraries (which varies significantly depending on the programming
   environment). For some builds it is simpler to make a Makefile for
   each compiler, which might be required for a more comprehensive build
   unless you are very familiar with gmake(1).

   If you always use one compiler it is relatively simple, otherwise
   make sure you know what your system requires and change the Makefile
   as appropriate.

![parse](docs/images/fpm_logo.gif)
## Build with FPM
   Alternatively, fpm(1) users may download the github repository and build it with
   fpm ( as described at [Fortran Package Manager](https://github.com/fortran-lang/fpm) )
```bash
        git clone https://github.com/urbanjost/M_CLI2.git
        cd M_CLI2
        fpm test   # build and test the module
        fpm install # install the module (in the default location)
```
   or just list it as a dependency in your fpm.toml project file.
```toml
        [dependencies]
        M_CLI2        = { git = "https://github.com/urbanjost/M_CLI2.git" }
```

## Supports Meson
   Alternatively, meson(1) users may download the github repository and build it with
   meson ( as described at [Meson Build System](https://mesonbuild.com/) )
```bash
        git clone https://github.com/urbanjost/M_CLI2.git
        cd M_CLI2
        meson setup _build
        meson test -C _build  # build and test the module

        # install the module (in the <DIR> location)
        # --destdir is only on newer versions of meson
        meson install -C _build --destdir <DIR>
        # older method if --destdir is not available
        env DESTDIR=<DIR> meson install -C _build
```
   or just list it as a [subproject dependency](https://mesonbuild.com/Subprojects.html) in your meson.build project file.
```meson
        M_CLI2_dep = subproject('M_CLI2').get_variable('M_CLI2_dep')
```

## Functional Specification
**This is how the interface works --**

* Pass in a string to set_args(3f) that looks almost like the command
  you would use to execute the program except with all keywords and
  default values specified.

* you add calls to the get_args(3f) procedure or one of its variants.
  The alternative convenience procedures (rget(3f),sget(3f),iget(3f)
  ...) allow you to use a simple function-based interface model. There
  are special routines for when you want to use fixed length.  CHARACTER
  variables or fixed-size arrays instead of the allocatable variables
  best used with get_args(3f)).

  Now when you call the program all the values in the prototype should
  be updated using values from the command line and queried and ready
  to use in your program.

![demos](docs/images/demo.gif)
## Demo Programs
These demo programs provide templates for the most common usage:

* [demo3](example/demo3.f90)   Example of **basic** use
* [demo1](example/demo1.f90)   Using the convenience functions
* [demo9](example/demo9.f90)   Long and short names using --LONGNAME:SHORTNAME.
* [demo2](example/demo2.f90)   Putting everything including **help** and **version** information into a contained procedure.
* [demo17](example/demo17.f90) Using unnamed options as filenames or strings
* [demo16](example/demo16.f90) Using unnamed values as numbers

## Optional Modes
* [demo15](example/demo15.f90) Allowing bundling short Boolean keys using "strict" mode
* [demo14](example/demo14.f90) Case-insensitive long keys
* [demo12](example/demo12.f90) Enabling response files
* [demo13](example/demo13.f90) Equivalencing dash to underscore in keynames

## Niche examples
* [demo8](example/demo8.f90)   Parsing multiple keywords in a single call to get_args(3f)
* [demo4](example/demo4.f90)   _COMPLEX_ type values
* [demo7](example/demo7.f90)   Controlling array delimiter characters
* [demo6](example/demo6.f90)   How to create a command with subcommands
* [demo5](example/demo5.f90)   extended description of using _CHARACTER_ type values

## Response files
[Response files](response.md) are supported as described in the documentation for
[set_args](https://urbanjost.github.io/M_CLI2/set_args.3m_cli2.html).
They are a system-independent way to create short abbreviations for long
complex commands. This option is generally not needed by programs with
just a few options, but can be particularly useful for programs with
dozens of options where various values are frequently reused.

## Commit Tests ##

commit `598e44164eee383b8a0775aa75b7d1bb100481c3` was tested on 2020-11-22 with
 + GNU Fortran (GCC) 8.3.1 20191121 (Red Hat 8.3.1-5)
 + ifort (IFORT) 19.1.3.304 20200925
 + nvfortran 20.7-0 LLVM 64-bit target on x86-64 Linux


commit `8fe841d8c0c1867f88847e24009a76a98484b31a` was tested on 2021-09-29 with
 + GNU Fortran (Ubuntu 10.3.0-1ubuntu1~20.04) 10.3.0
 + ifort (IFORT) 2021.3.0 20210609
 + nvfortran 21.5-0 LLVM 64-bit target on x86-64 Linux -tp nehalem

commit `732bcadf95e753ccdf025cec2c08d776ea2534c2` was tested on 2023-02-10 with
 + ifort (IFORT) 2021.8.0 20221119
 + GNU Fortran (Ubuntu 11.1.0-1ubuntu1~20.04) 11.1.0
---
<!--
Last updated:   Wed Sep 29 17:34:52 2021 -0400
Last update: Sat 21 Jan 2023 11:10:53 PM EST
-->
Last update: Saturday, February 4th, 2023 1:12:54 AM UTC-05:00

program demo9
!> @(#) long and short names using --LONGNAME:SHORTNAME
!!
!!  When all keys have a long and short name and "strict mode" is invoked
!!  where "-" is required for short names and "--" for long names Boolean
!!  values may be bundled together. For example:
!!
!!    demo9 -XYZ
!!
use M_CLI2,  only : set_args, sget, rget, lget, set_mode
implicit none
character(len=*),parameter :: all='(*(g0))'

   print *,'demo9: long and short names using --LONGNAME:SHORTNAME'
   !call set_mode('strict')
   call set_args('    &
   & --length:l 10    &
   & --height:h 12.45 &
   & --switchX:X F    &
   & --switchY:Y F    &
   & --switchZ:Z F    &
   & --title:T "my title"')
   print all,'--length or -l .... ',rget('length')
   print all,'--height or -h .... ',rget('height')
   print all,'--switchX or -X ... ',lget('switchX')
   print all,'--switchY or -Y ... ',lget('switchY')
   print all,'--switchZ or -Z ... ',lget('switchZ')
   print all,'--title or -T ..... ',sget('title')
end program demo9

program test_lastonly
!> @(#) unnamed to numbers
!! The default for inums, rnums, ... is to convert all unnamed argument values in "unnamed"
use, intrinsic :: iso_fortran_env, only : stderr=>ERROR_UNIT, stdin=>INPUT_UNIT, stdout=>OUTPUT_UNIT
use M_CLI2,  only : set_args, sget, igets, rgets, dgets, lget, set_mode
implicit none
character(len=*),parameter :: it='(1x,*(g0,1x))'
logical,parameter :: T=.true., F=.false.
character(len=:),allocatable :: whichone
logical,allocatable :: arr(:)
   call set_mode('strict')
   call set_mode('lastonly')
   call set_args(' --type run -o F -t F -x F --ox F --xo F --longa:O F --longb:X F -a "aaa" --stringb:b "bbb BBB" -c "cc c C CC"')
   whichone=sget('type')
   arr=[lget('o'),lget('t'),lget('x'),lget('ox'),lget('xo'),lget('longa'),lget('longb')]
   select case(whichone)
   case('one')   ; call testit(whichone,.not.any(arr))
   case('two')   ; call testit(whichone,all(arr))
   case('three') ; call testit(whichone,all(arr))
   case('four')  ; call testit(whichone,all(arr.eqv.[F,F,F,F,F,T,F]))
   case('five')  ; call testit(whichone,all(arr.eqv.[T,T,T,F,F,T,T]))
   case('six')   ; call testit(whichone,all(arr))
   case('seven') ; print it,'a=',sget('a');             call testit(whichone,sget('a')=='a b c')
   case('eight') ; print it,'stringb=',sget('stringb'); call testit(whichone,sget('stringb')=='a b c')
   case('nine')  ; print it,'stringb=',sget('stringb'); call testit(whichone,sget('stringb')=='a b c')
   case('run')
      print *,'test_lastonly: lastonly mode'
      call runit('--type one')
      call runit('--type two -oxt --ox --xo -OX --longa --longb')
      call runit('--type three -t -o -x  --ox --xo -O -X --longa --longb')
      call runit('--type four --longa --longa --longa --longa')
      call runit('--type five -t -o -x --longa --longb -O -X -OX -XO --longb')
      call runit('--type six -ox -t --ox --xo --longa --longb -xt -o --ox --xo --longa --longb')
      call runit('--type seven -a "a b c"')
      call runit('--type eight -b "a b c"')
      call runit('--type nine  --stringb "a b c"')
   case default
      print it,'unknown type'
   end select
contains

subroutine testit(string,test)
character(len=*),intent(in) :: string
logical,intent(in) :: test

   write(*,it,advance='no')arr
   if(test)then
      print it,':lastonly:',string,'passed'
   else
      print it,':lastonly:',string,'failed'
      stop 1
   endif

end subroutine testit

subroutine runit(string)
character(len=*),intent(in) :: string
character(len=4096) :: cmd
   call get_command_argument(0,cmd)
   write(stdout,*)'RUN:',trim(cmd)//' '//string
   call execute_command_line(trim(cmd)//' '//string)
end subroutine runit

end program test_lastonly

program demo2
!!  @(#) all parsing and **help** and **version** information in a contained procedure.
use M_CLI2,  only : unnamed
implicit none
integer            :: i

!! DEFINE "ARGS" VALUES
integer            :: x, y, z
real               :: point(3)
character(len=80)  :: title
logical            :: l, l_

   print *,'demo2: all parsing and **help** and **version** information in a contained procedure'

   call parse() !! DEFINE AND PARSE COMMAND LINE

   !! ALL DONE CRACKING THE COMMAND LINE USE THE VALUES IN YOUR PROGRAM.
   write(*,*)x+y+z
   write(*,*)point*2
   write(*,*)title
   write(*,*)l,l_

   !! THE OPTIONAL UNNAMED VALUES ON THE COMMAND LINE ARE
   !! ACCUMULATED IN THE CHARACTER ARRAY "UNNAMED"
   if(size(unnamed) > 0)then
      write(*,'(a)')'files:'
      write(*,'(i6.6,3a)')(i,'[',unnamed(i),']',i=1,size(unnamed))
   endif

contains
subroutine parse()
!! PUT EVERYTHING TO DO WITH COMMAND PARSING HERE FOR CLARITY
use M_CLI2,  only : set_args, get_args
use M_CLI2,  only : get_args_fixed_size,get_args_fixed_length
character(len=:),allocatable  :: help_text(:), version_text(:)

!! DEFINE COMMAND PROTOTYPE
!!  o All parameters   must be listed with a default value
!!  o string values    must be double-quoted
!!  o numeric lists    must be comma-delimited. No spaces are allowed
!!  o long keynames    must be all lowercase

character(len=*),parameter :: cmd='&
   & -x 1 -y 2 -z 3     &
   & --point -1,-2,-3   &
   & --title "my title" &
   & -l F -L F          &
   & '

   help_text=[character(len=80) :: &
      'NAME                                                    ', &
      '   myprocedure(1) - make all things possible            ', &
      'SYNOPSIS                                                ', &
      '   function myprocedure(stuff)                          ', &
      '   class(*) :: stuff                                    ', &
      'DESCRIPTION                                             ', &
      '   myprocedure(1) makes all things possible given STUFF ', &
      'OPTIONS                                                 ', &
      '   STUFF  things to do things to                        ', &
      'RETURNS                                                 ', &
      '   MYPROCEDURE  the answers you want                    ', &
      'EXAMPLE                                                 ', &
      '' ]

   version_text=[character(len=80) :: &
      '@(#)PROGRAM:     demo2            >', &
      '@(#)DESCRIPTION: My demo program  >', &
      '@(#)VERSION:     1.0 20200115     >', &
      '@(#)AUTHOR:      me, myself, and I>', &
      '@(#)LICENSE:     Public Domain    >', &
      '' ]

   call set_args(cmd, help_text, version_text)
   call get_args('x',x)
   call get_args('y',y)
   call get_args('z',z)
   call get_args_fixed_size('point',point)
   call get_args_fixed_length('title',title)
   call get_args('l',l)
   call get_args('L',l_)

end subroutine parse

end program demo2

      program demo_M_CLI2
      use M_CLI2,  only : set_args, get_args
      use M_CLI2,  only : filenames=>unnamed
      use M_CLI2,  only : get_args_fixed_length, get_args_fixed_size
      implicit none
      integer                      :: i
      integer,parameter            :: dp=kind(0.0d0)
       !
       ! Define ARGS
      real                         :: x, y, z
      logical                      :: l, lbig
      character(len=40)            :: label    ! FIXED LENGTH
      real(kind=dp),allocatable    :: point(:)
      logical,allocatable          :: logicals(:)
      character(len=:),allocatable :: title    ! VARIABLE LENGTH
      real                         :: p(3)     ! FIXED SIZE
      logical                      :: logi(3)  ! FIXED SIZE
       !
       ! DEFINE AND PARSE (TO SET INITIAL VALUES) COMMAND LINE
       !   o set a value for all keywords.
       !   o double-quote strings, strings must be at least one space
       !     because adjacent double-quotes designate a double-quote
       !     in the value.
       !   o set all logical values to F
       !   o numeric values support an "e" or "E" exponent
       !   o for lists delimit with a comma, colon, or space
      call set_args('                         &
              & -x 1 -y 2 -z 3                &
              & -p -1 -2 -3                   &
              & --point 11.11, 22.22, 33.33e0 &
              & --title "my title" -l F -L F  &
              & --logicals  F F F F F         &
              & --logi F T F                  &
              & --label " " &
              ! note space between quotes is required
              & ')
       ! Assign values to elements using G_ARGS(3f).
       ! non-allocatable scalars can be done up to twenty per call
      call get_args('x',x, 'y',y, 'z',z, 'l',l, 'L',lbig)
       ! As a convenience multiple pairs of keywords and variables may be
       ! specified if and only if all the values are scalars and the CHARACTER
       ! variables are fixed-length or pre-allocated.
       !
       ! After SET_ARGS(3f) has parsed the command line
       ! GET_ARGS(3f) retrieves the value of keywords accept for
       ! two special cases. For fixed-length CHARACTER variables
       ! see GET_ARGS_FIXED_LENGTH(3f). For fixed-size arrays see
       ! GET_ARGS_FIXED_SIZE(3f).
       !
       ! allocatables should be done one at a time
      call get_args('title',title) ! allocatable string
      call get_args('point',point) ! allocatable arrays
      call get_args('logicals',logicals)
       !
       ! less commonly ...

       ! for fixed-length strings
      call get_args_fixed_length('label',label)

       ! for non-allocatable arrays
      call get_args_fixed_size('p',p)
      call get_args_fixed_size('logi',logi)
       !
       ! all done parsing, use values
      write(*,*)'x=',x, 'y=',y, 'z=',z, x+y+z
      write(*,*)'p=',p
      write(*,*)'point=',point
      write(*,*)'title=',title
      write(*,*)'label=',label
      write(*,*)'l=',l
      write(*,*)'L=',lbig
      write(*,*)'logicals=',logicals
      write(*,*)'logi=',logi
       !
       ! unnamed strings
       !
      if(size(filenames) > 0)then
         write(*,'(i6.6,3a)')(i,'[',filenames(i),']',i=1,size(filenames))
      endif
       !
      end program demo_M_CLI2

program demo12
!!  @(#) using the convenience functions
use M_CLI2, only : set_args, set_mode, rget
implicit none
real :: x,  y,  z

   print *,'demo12: using the convenience functions'

!! ENABLE USING RESPONSE FILES
   call set_mode('response file')

   call set_args('-x 1.1 -y 2e3 -z -3.9 ')
   x = rget('x')
   y = rget('y')
   z = rget('z')
!! USE THE VALUES IN YOUR PROGRAM.
   write(*, '(*(g0:,1x))')'x=',x, 'y=',y, 'z=',z, 'SUM=',x+y+z

end program demo12

program demo11
!! @(#) examples of validating values with ALL(3f) and ANY(3f)
use, intrinsic :: iso_fortran_env, only : stderr=>ERROR_UNIT, stdin=>INPUT_UNIT, stdout=>OUTPUT_UNIT
implicit none
type point
   integer           :: x=0
   integer           :: y=0
   character(len=20) :: color='red'
endtype point

type(point) :: dot; namelist /nml_dot/ dot

character(len=:),allocatable :: name
character(len=:),allocatable :: string
character(len=:),allocatable :: list(:)
character(len=80)            :: readme !(3)
integer                      :: i

print *,'demo11: examples of validating values with ALL(3f) and ANY(3f)'

! M_CLI2 intentionally does not have complex validators except for SPECIFIED(3f) and
! a check whether the input conforms to the type with get_args(3f)
! or the convenience functions like inum(3f). 
!
! Fortran already has powerful validation capabilities.  Logical
! expressions ANY(3f) and ALL(3f) are standard Fortran features easily
! allow performing the common validations for command line arguments
! without having to learn any additional syntax or methods.

do i=1,100
   if(all([i >= 10,i <= 30,(i/2)*2 == i]))then
      write(*,*)i,' is an even number from 10 to 30 inclusive'
   endif
enddo

name='red'
list = [character(len=10) :: 'red','white','blue']
if( any(name == list) )then
   write(*,*)name,' matches a value in the list'
else
   write(*,*)name,' not in the list'
endif

if(size(list).eq.3)then
   write(*,*)' list has expected number of values'
else
   write(*,*)' list does not have expected number of values'
endif

! and even user-defined types can be processed by reading the input
! as a string and using a NAMELIST(3f) group to convert it. Note that
! if input values are strings that have to be quoted (ie. more than one
! word) or contain characters special to the shell that how you have to
! quote the command line can get complicated.

string='10,20,"green"'

readme='&nml_dot dot='//string//'/'

! some compilers might require the input to be on three lines
!readme=[ character(len=80) ::&
!'&nml_dot', &
!'dot='//string//' ,', &
!'/']

read(readme,nml=nml_dot)

write(*,*)dot%x,dot%y,dot%color
! or
write(*,nml_dot)

! Hopefully it is obvious how the options can be read from values gotten
! with SGET(3f) and SGETS(3f) in this case, and with functions like IGET(3f)
! in the first case, so this example just uses simple declarations to highlight
! some useful Fortran expressions that can be useful for validating the input
! or even reading user-defined types or even intrinsics via NAMELIST(7f) groups.

! another alternative would be to validate expressions from strings using M_calculator(3f)
! but I find it easier to validate the values using regular Fortran code than doing it
! via M_CLI2(3f), although if TLI (terminal screen GUIs) or GUIs are supported later by
! M_CLI2(3f) doing validation in the input forms themselves would be more desirable.

end program demo11

program demo14
!> @(#) ignorecase mode
!!
!! long keynames are internally converted to lowercase
!! when ignorecase mode is on these are equivalent
!!
!!     demo14 --longName
!!     demo14 --longname
!!     demo14 --LongName
!!
!! Values and short names remain case-sensitive
!!
use M_CLI2,  only : set_args, lget, set_mode
implicit none
character(len=*),parameter :: all='(*(g0))'

   print *,'demo14: ignorecase mode'

   call set_mode('ignorecase')
   call set_args(' --longName:N F ')
   print all,'--longName or -N ... ',lget('longName')
end program demo14

program demo15
!> @(#) strict mode
!!
!! In strict mode short single-character names may be bundled but it is
!! required that a single dash is used, where normally single and double
!! dashes are equivalent.
!!
!!     demo15 -o -t -x
!!     demo15 -otx
!!     demo15 -xto      
!!
!! Only Boolean keynames may be bundled together
!!
use M_CLI2,  only : set_args, lget, set_mode
implicit none
character(len=*),parameter :: all='(*(g0))'

   print *,'demo15: strict mode'

   call set_mode('strict')
   call set_args(' -o F -t F -x F --ox F')
   print all,'o=',lget('o'),' t=',lget('t'),' x=',lget('x'),' ox=',lget('ox')
end program demo15

program demo6
!! @(#) SUBCOMMANDS
!!
!! For a command with subcommands like git(1) you can call this program
!! which has two subcommands (run, test), like this:
!!
!!    demo6 --help
!!    demo6 run -x -y -z -title -l -L
!!    demo6 test -title -l -L -testname
!!    demo6 run --help
!!
use M_CLI2, only : set_args, get_args, get_args_fixed_length, get_subcommand
use M_CLI2, only : rget,sget,lget
use M_CLI2, only : CLI_RESPONSE_FILE
implicit none
character(len=:),allocatable   :: name    ! the subcommand name
character(len=:),allocatable   :: version_text(:), help_text(:)
! define some values to use as arguments 
character(len=80)  :: title, testname
logical            :: l, l_

   print *,'demo6: creating subcommands'

   version_text=[character(len=80) :: &
   '@(#)PROGRAM:     demo6            >', &
   '@(#)DESCRIPTION: My demo program  >', &
   '@(#)VERSION:     1.0 20200715     >', &
   '@(#)AUTHOR:      me, myself, and I>', &
   '@(#)LICENSE:     Public Domain    >', &
   '' ]
   CLI_RESPONSE_FILE=.true.
   ! find the subcommand name by looking for first word on command
   ! not starting with dash
   name = get_subcommand()

   ! define commands and parse command line and set help text and process command
   select case(name) 

   case('run')
      help_text=[character(len=80) :: &
       '                                  ', &
       ' Help for subcommand "run"        ', &
       '                                  ', &
       '' ]
      call set_args('-x 1 -y 2 -z 3 --title "my title" -l F -L F',help_text,version_text)
      ! example using convenience functions to retrieve values and pass them
      ! to a routine
      call my_run(rget('x'),rget('y'),rget('z'),sget('title'),lget('l'),lget('L'))

   case('test')
      help_text=[character(len=80) :: &
       '                                  ', &
       ' Help for subcommand "test"       ', &
       '                                  ', &
       '' ]
      call set_args('--title "my title" -l F -L F --testname "Test"',help_text,version_text)
      ! use get_args(3f) to extract values and use them
      call get_args_fixed_length('title',title)
      call get_args('l',l)
      call get_args('L',l_)
      call get_args_fixed_length('testname',testname)
      ! all done cracking the command line. use the values in your program.
      write(*,*)'command was ',name
      write(*,*)'title .... ',trim(title)
      write(*,*)'l,l_ ..... ',l,l_
      write(*,*)'testname . ',trim(testname)

   case('')
      ! general help for "demo6 --help"
      help_text=[character(len=80) :: &
       ' General help describing the       ', &
       ' program.                          ', &
       '' ]
      call set_args(' ',help_text,version_text) ! process help and version

   case default
      call set_args(' ',help_text,version_text) ! process help and version
      write(*,'(*(a))')'unknown or missing subcommand [',trim(name),']'

   end select

contains

subroutine my_run(x,y,z,title,l,l_)
! nothing about commandline parsing here!
real,intent(in)              :: x,y,z
character(len=*),intent(in)  :: title
logical,intent(in)           :: l
logical,intent(in)           :: l_
   write(*,*)'MY_RUN'
   write(*,*)'x,y,z .....',x,y,z
   write(*,*)'title .... ',title
   write(*,*)'l,l_ ..... ',l,l_
end subroutine my_run

end program demo6

      program demo_get_args
      use M_CLI2,  only : filenames=>unnamed, set_args, get_args
      implicit none
      integer                      :: i
       ! Define ARGS
      real                         :: x, y, z
      real,allocatable             :: p(:)
      character(len=:),allocatable :: title
      logical                      :: l, lbig
       ! Define and parse (to set initial values) command line
       !   o only quote strings and use double-quotes
       !   o set all logical values to F or T.
      call set_args('         &
         & -x 1 -y 2 -z 3     &
         & -p -1,-2,-3        &
         & --title "my title" &
         & -l F -L F          &
         & --label " "        &
         & ')
       ! Assign values to elements
       ! Scalars
      call get_args('x',x,'y',y,'z',z,'l',l,'L',lbig)
       ! Allocatable string
      call get_args('title',title)
       ! Allocatable arrays
      call get_args('p',p)
       ! Use values
      write(*,'(1x,g0,"=",g0)')'x',x, 'y',y, 'z',z
      write(*,*)'p=',p
      write(*,*)'title=',title
      write(*,*)'l=',l
      write(*,*)'L=',lbig
      if(size(filenames) > 0)then
         write(*,'(i6.6,3a)')(i,'[',filenames(i),']',i=1,size(filenames))
      endif
      end program demo_get_args

program demo3
!!  example of **basic** use
!*! JUST THE BARE ESSENTIALS
use M_CLI2,  only : set_args, get_args
implicit none
integer                      :: x, y
logical                      :: l
real                         :: size
character(len=:),allocatable :: title
   call set_args('-x 1 -y 10 --size:s 12.34567  -l F --title:t "my title"')
   call get_args('x',x, 'y',y,'l',l, 'size',size) ! all the non-allocatables
   call get_args('title',title)
   ! all variables set and of the right type
   write(*,'(*("[",g0,"]":,1x))')x,y,size,l,title
end program demo3

program demo13
!> @(#) underdash mode
!! Any dash in a key name is treated as an underscore
!! when underdash mode is on 
!!
!!     demo13 --switch-X
!!     demo13 --switch_X
!!
!! are equivalent when this mode is on
!!
use M_CLI2,  only : set_args, lget, set_mode
implicit none
character(len=*),parameter :: all='(*(g0))'

   print *,'demo13: underdash mode'

   call set_mode('underdash')
   call set_args(' --switch_X:X F --switch-Y:Y F ')
   print all,'--switch_X or -X ... ',lget('switch_X')
   print all,'--switch_Y or -Y ... ',lget('switch_Y')
end program demo13

program basic
!! STACK OF TESTS -- some systems will have a limit on how much process spawning is allowed
use M_CLI2,  only : set_args, get_args
use M_CLI2,  only : get_args_fixed_length, get_args_fixed_size
implicit none

integer                      :: casen=0

integer                      :: x,y,z      
integer                      :: ithree(3)
integer,allocatable          :: ints(:)

real                         :: r_x,r_y,r_z      
real                         :: rfour(4)
real,allocatable             :: reals(:)

logical                      :: l_x,l_y
logical                      :: lfive(5)
logical,allocatable          :: logicals(:)

character(len=30)            :: string     

complex                      :: c_x, c_y, c_z   ! scalars
complex,allocatable          :: c_aarr(:)       ! allocatable array
complex                      :: c_three(3)      ! fixed-size array

character(len=:),allocatable :: command
character(len=4096)          :: cmd
integer                      :: e
integer                      :: i
character(len=*),parameter   :: gen='(*(g0,1x))'

   call get_command_argument(0,cmd) ! get name of this executable
   e=len_trim(cmd)+1
   
   command=' &
   & --ints 11,22,33,b111,o111,z111 &
   & -x 10 -y 20 -z 10#30 &
   & --ithree -1,-2,-3 &
   ! character
   & -string "My string,""again" &
   ! real
   & -r_x -8 -r_y -88 -r_z -888 &
   & --reals 1.2,2.3,3.4,4.5,5.6,6.7,7.8 &
   & --rfour 1.1,2.2,3.3,4.4 &
   ! logical
   & --logicals T:.true:.TRUE.:.false.:F:FALSE:TRUE -l_x T -l_y F -lfive T,F,T,F,T & 
   ! complex
   & --c_three -999,-999,-999,-999,-999,-999 &
   & -c_x -999,-999 -c_y -999,-999 -c_z -999,-999 &
   & --c_aarr -999:-999::-999:-999 &
   ! case number
   & -casen 0 &
   &'
   call readcli()                              ! assume initially called with no parameters so that parameters are default values
   select case(casen)
   case(0)
      write(6,*)'COMMAND:',command
      write(6,*)'check defaults'

      write(6,*)'default integers'
      call printit(all([x,y,z,ints,ithree] == [10,20,30,11,22,33,7,73,273,-1,-2,-3]))

      write(6,*)'default reals scalar'
      call printit(all([r_x,r_y,r_z] == [-8.0,-88.0,-888.0]))
      write(6,*)'default reals fixed array'
      call printit(all(rfour == [1.1,2.2,3.3,4.4])) 
      write(6,*)'default allocatable array'
      write(*,*)reals
      write(*,*)[1.2,2.3,3.4,4.5,5.6,6.7,7.8]
      call printit(all(reals == [1.2,2.3,3.4,4.5,5.6,6.7,7.8]))

      write(6,*)'default logicals'
      call printit(all([l_x ,l_y,lfive,logicals].eqv. &
      & [.true., .false., .true., .false., .true., .false., .true., .true., .true., .true., .false., .false., .false., .true.]))

      write(6,*)'default complex'
      call printit(all([c_x,c_y,c_z,c_three,c_aarr] ==  [(cmplx(-999,-999),i=1,8)]))

      call runit('-x 4 -y 5 -z 6 -casen 1')       ! now call itself with some values specified
   case(1)
      write(6,*)'scalar ints'
      call printit(all([x,y,z] == [4,5,6]))       ! options set on command line in previous case
      call runit('-r_x 40 -r_y 50 -r_z 60 -casen 2')
   case(2)
      write(6,*)'scalar reals'
      call printit(all([r_x,r_y,r_z] == [40.0,50.0,60.0]))
      call runit('-x 400 -y 500 -z 600 --ints -1,-2,-3 --ithree -11,-22,-33 -casen 3')
   case(3)
      call printit(all([x,y,z,ints,ithree] == [400,500,600,-1,-2,-3,-11,-22,-33]))
      call runit('-c_x "(1,2)" -c_y 10,20 -c_z "(2#111,16#-AB)" -c_three 1,2,3,4,5,6 -c_aarr 111::222,333::444 -casen 4')
   case(4)
      ! test results for case 4

      write(6,gen)'CASE4 EXPECTED:',&
      [cmplx(1.0,2.0),cmplx(10.0,20.0),cmplx(7,-171),cmplx(1,2),cmplx(3,4),cmplx(5,6),cmplx(111,222),cmplx(333,444)]
         
      write(6,gen)'CASE4 RESULTS:',[c_x,c_y,c_z,c_three,c_aarr]

      write(6,gen)'CASE4 TESTS:',[c_x,c_y,c_z,c_three,c_aarr] == &
      & [cmplx(1.0,2.0),cmplx(10.0,20.0),cmplx(7,-171),cmplx(1,2),cmplx(3,4),cmplx(5,6),cmplx(111,222),cmplx(333,444)]

      call printit(all([c_x,c_y,c_z,c_three,c_aarr] == &
      & [cmplx(1.0,2.0),cmplx(10.0,20.0),cmplx(7,-171),cmplx(1,2),cmplx(3,4),cmplx(5,6),cmplx(111,222),cmplx(333,444)]))

      flush(unit=6)

      ! run next case
      call runit('-x 400 -y 500 -z 600 --ints -1,-2,-3 -casen 900')
   case(5)
   case(6)
   case(7)
   case(8)
   case(9)
   case(900)
      write(6,*)'USAGE'
      flush(unit=6)
      call runit('--casen 901 --usage')
      call runit('--casen 901')
   case(901)
      write(6,*)'HELP'
      flush(unit=6)
      call runit('--casen 902 --help')
      call runit('--casen 902')
   case(902)
      write(6,*)'VERSION'
      flush(unit=6)
      call runit('--casen 999 --version')
      call runit('--casen 999')
   case(999)
   case default
      write(6,'(a)')'default - should not get here'
      flush(unit=6)
      stop
   end select

contains

subroutine runit(string)
character(len=*),intent(in) :: string
      write(6,*)'RUN:',string
      flush(unit=6)
      call execute_command_line(cmd(:e)//string)
end subroutine runit

subroutine printit(testit)
logical testit
   write(6,'(*(g0,1x))',advance='no')'CASE ',casen,merge('PASSED:','FAILED:',testit)
   write(6,'(/,a)')repeat('=',132)
   flush(unit=6)
end subroutine printit

subroutine readcli()
   flush(unit=6)
   call set_args(command)
   ! integer
   call get_args('x',x)
   call get_args('y',y)
   call get_args('z',z)
   call get_args('ints',ints)
   call get_args_fixed_size('ithree',ithree)
   ! logical
   call get_args('l_x',l_x)
   call get_args('l_y',l_y)
   call get_args('logicals',logicals)
   call get_args_fixed_size('lfive',lfive)
   ! real
   call get_args('r_x',r_x)
   call get_args('r_y',r_y)
   call get_args('r_z',r_z)
   call get_args('reals',reals)
   call get_args_fixed_size('rfour',rfour)
   ! character
   call get_args_fixed_length('string',string)
   ! complex
   call get_args('c_x',c_x)
   call get_args('c_y',c_y)
   call get_args('c_z',c_z)
   call get_args('c_aarr',c_aarr)
   call get_args_fixed_size('c_three',c_three)
   !
   call get_args('casen',casen)
end subroutine readcli

end program basic

     program demo_set_mode
     use M_CLI2,  only : set_args, lget, set_mode
     implicit none
     character(len=*),parameter :: all='(*(g0))'
        !
        ! enable use of response files
        call set_mode('response_file')
        !
        ! Any dash in a keyword is treated as an underscore
        call set_mode('underdash')
        !
        ! The case of long keywords are ignored.
        ! Values and short names remain case-sensitive
        call set_mode('ignorecase')
        !
        ! short single-character boolean keys may be bundled
        ! but it is required that a single dash is used for
        ! short keys and a double dash for long keywords.
        call set_mode('strict')
        !
        call set_args(' --switch_X:X F --switch-Y:Y F --ox:O F -t F -x F -o F')
        !
        print all,'--switch_X or -X ... ',lget('switch_X')
        print all,'--switch_Y or -Y ... ',lget('switch_Y')
        print all,'--ox or -O       ... ',lget('ox')
        print all,'-o               ... ',lget('o')
        print all,'-x               ... ',lget('x')
        print all,'-t               ... ',lget('t')
     end program demo_set_mode

      program demo_get_args_fixed_length
      use M_CLI2,  only : set_args, get_args_fixed_length
      implicit none

       ! Define args
      character(len=80)   :: title
       ! Parse command line
      call set_args(' --title "my title" ')
       ! Assign values to variables
      call get_args_fixed_length('title',title)
       ! Use values
      write(*,*)'title=',title

      end program demo_get_args_fixed_length

program demo1
!!  @(#) using the convenience functions
use M_CLI2, only : set_args, get_args_fixed_size, set_mode
use M_CLI2, only : dget,  iget,  lget,  rget,  sget,  cget ! for scalars
use M_CLI2, only : dgets, igets, lgets, rgets, sgets, cgets ! for allocatable arrays
implicit none

!! DECLARE "ARGS"
real                           :: x,  y,  z,  point(3)
character(len=:), allocatable  :: title, anytitle
logical                        :: l,  lupper

   print *,'demo1: using the convenience functions'

   call set_mode('response_file')
!! SET ALL ARGUMENTS TO DEFAULTS WITH SHORT NAMES FOR LONG NAMES AND THEN ADD COMMAND LINE VALUES
   call set_args('-x 1.1 -y 2e3 -z -3.9 --point:p -1,-2,-3 --title:T "my title" --anytitle:a "my title" -l F -L F')

!! ALL DONE CRACKING THE COMMAND LINE. GET THE VALUES
   x = rget('x')
   y = rget('y')
   z = rget('z')
   l = lget('l')
   lupper = lget('L')
   title = sget('title') 
   anytitle = sget('anytitle') 

   ! With a fixed-size array to ensure the correct number of values are input use
   call get_args_fixed_size('point',point)

!! USE THE VALUES IN YOUR PROGRAM.
   write(*, '(*(g0:,1x))')'x=',x, 'y=',y, 'z=',z, 'SUM=',x+y+z, ' point=',point
   write(*, '(*(g0:,1x))')'title=', trim(title),  ' l=', l, 'L=', lupper
   write(*, '(*(g0:,1x))')'anytitle=', trim(anytitle)

end program demo1

!! NOTES: WHEN DEFINING THE PROTOTYPE
   !  o All parameters must be listed with a default value
   !  o string values must be double-quoted
   !  o numeric lists must be comma-delimited. No spaces are allowed
   !  o long keynames must be all lowercase but may be followed by :LETTER where LETTER is a
   !    single letter that may be of any case that will act as a short name for the same value.

program demo5
!! @(#) _CHARACTER_ type values
!! character variables have a length, unlike number variables
use M_CLI2, only : set_args, get_args
use M_CLI2, only : get_args_fixed_size, get_args_fixed_length
use M_CLI2, only : sget, sgets
implicit none

character(len=*),parameter   :: fmt='(*("[",g0,"]":,1x))'

   print *,'demo5: CHARACTER argument examples'

   call set_args(' &
   & --alloc_len_scalar " " &
   & --fx_len_scalar " " &
   & --alloc_array "A,B,C" &
   & --fx_size_fx_len "A,B,C" &
   & --fx_len_alloc_array "A,B,C" &
   & ')

   block
   ! you just need get_args(3f) for general scalars or arrays
   ! variable length scalar
   character(len=:),allocatable  :: alloc_len_scalar 
   ! variable array size and variable length
   character(len=:),allocatable  :: alloc_array(:) 
   call get_args('alloc_len_scalar',        alloc_len_scalar)
   write(*,fmt)'allocatable length scalar=',alloc_len_scalar,&
   & len(alloc_len_scalar)

   call get_args('alloc_array',             alloc_array) 
   write(*,fmt)'allocatable array=        ',alloc_array
   endblock

   ! less commonly, if length or size is fixed, use a special function

   block
   character(len=19),allocatable                 :: fx_len_alloc_array(:) 
   call get_args_fixed_length('fx_len_alloc_array', fx_len_alloc_array)
   write(*,fmt)'fixed length allocatable array=',   fx_len_alloc_array
   endblock

   block
   character(len=19)                        :: fx_len_scalar   
   call get_args_fixed_length('fx_len_scalar', fx_len_scalar)
   write(*,fmt)'fixed length scalar=        ', fx_len_scalar
   endblock

   block
   character(len=19)                        :: fx_size_fx_len(3) 
   call get_args_fixed_size('fx_size_fx_len',  fx_size_fx_len) 
   write(*,fmt)'fixed size fixed length=    ', fx_size_fx_len
   endblock

   block
   ! or (recommended) set to an allocatable array and check size and
   ! length returned
   character(len=:),allocatable  :: a        ! variable length scalar
   character(len=:),allocatable  :: arr(:)   ! variable array size and variable length
   call get_args('fx_size_fx_len',arr)
   ! or
   arr=sgets('fx_size_fx_len')
   if(size(arr) /= 3)write(*,*)'not right size'
   if(len(arr) > 19)write(*,*)'longer than wanted'

   call get_args('fx_len_scalar',a)
   !or
   a=sget('fx_len_scalar')
   if(len(a) > 19)write(*,*)'too long'
   write(*,*)a,len(a)
   write(*,*)arr,len(arr),size(arr)

   endblock

end program demo5

program test_ignorecase
!> @(#) unnamed to numbers
!! The default for inums, rnums, ... is to convert all unnamed argument values in "unnamed"
use, intrinsic :: iso_fortran_env, only : stderr=>ERROR_UNIT, stdin=>INPUT_UNIT, stdout=>OUTPUT_UNIT
use M_CLI2,  only : set_args, sget, igets, rgets, dgets, lget, set_mode
implicit none
character(len=*),parameter :: it='(1x,*(g0,1x))'
character(len=:),allocatable :: whichone
character(len=:),allocatable :: arr(:)
   call set_mode('ignorecase')

   call set_args(' --type run -a "a AA a" -b "B bb B"  -A AAA -B BBB --longa:O " OoO " --longb:X "xXx"')
   whichone=sget('type')
   arr=[character(len=17) :: sget('a'),sget('b'),sget('A'),sget('B'),sget('longa'),sget('longb'),sget('O'),sget('X') ]
   select case(whichone)
   case('one')   ; call testit(whichone,all([character(len=17)::'a AA a','B bb B','AAA','BBB',' OoO','xXx',' OoO','xXx']==arr))
   case('two')   ; call testit(whichone,all([character(len=17)::'a','b','A','B','longa O','longb X','longa O','longb X']==arr))
   case('three') ; call testit(whichone,all([character(len=17)::'a','b','A','B','longa O','longb X','longa O','longb X']==arr))
   case('four')  ; call testit(whichone,all([character(len=17)::'a A','b B','SET A','SET B',' OoO','xXx',' OoO','xXx']==arr))
   case('five')  ; call testit(whichone,all([character(len=17)::'a AA a','B bb B','AAA','BBB', &
                   & 'a b c d e f g h i','xXx','a b c d e f g h i','xXx']==arr))
   case('six')   ; !call testit(whichone,  all(arr))
   case('run')
      print *,'test_ignorecase: ignorecase mode'
      call runit('--type one ')
      call runit('--type two   -a  a -b b  -A A -B B   -longa longa -longb   longb -O  O -X X ')
      call runit('--type three -a a -b  b -A A  -B B -LONGA   longa -LONGB   longb -O O -X  X')
      call runit('--type four -a a -b  b -a A  -b B -A "SET A" -B "SET B"')
      call runit('--type five --LongA "a b c" -longa "d e f" -longA "g h i"')
!      call runit('--type six -ox -t --ox --xo --longa --longb')
   case default
      print it,'unknown type'
   end select
contains

subroutine testit(string,test)
character(len=*),intent(in) :: string
logical,intent(in) :: test

   write(*,it,advance='no')arr
   if(test)then
      print it,':ignorecase:',string,'passed'
   else
      print it,':ignorecase:',string,'failed'
      stop 1
   endif

end subroutine testit

subroutine runit(string)
character(len=*),intent(in) :: string
character(len=4096) :: cmd
   call get_command_argument(0,cmd)
   write(stdout,*)'RUN:',trim(cmd)//' '//string
   call execute_command_line(trim(cmd)//' '//string)
end subroutine runit

end program test_ignorecase

     program demo_get_subcommand
     !x! SUBCOMMANDS
     !x! For a command with subcommands like git(1)
     !x! you can make separate namelists for each subcommand.
     !x! You can call this program which has two subcommands (run, test),
     !x! like this:
     !x!    demo_get_subcommand --help
     !x!    demo_get_subcommand run -x -y -z --title -l -L
     !x!    demo_get_subcommand test --title -l -L --testname
     !x!    demo_get_subcommand run --help
        implicit none
     !x! DEFINE VALUES TO USE AS ARGUMENTS WITH INITIAL VALUES
        real               :: x=-999.0,y=-999.0,z=-999.0
        character(len=80)  :: title="not set"
        logical            :: l=.false.
        logical            :: l_=.false.
        character(len=80)  :: testname="not set"
        character(len=20)  :: name
        call parse(name) !x! DEFINE AND PARSE COMMAND LINE
        !x! ALL DONE CRACKING THE COMMAND LINE.
        !x! USE THE VALUES IN YOUR PROGRAM.
        write(*,*)'command was ',name
        write(*,*)'x,y,z .... ',x,y,z
        write(*,*)'title .... ',title
        write(*,*)'l,l_ ..... ',l,l_
        write(*,*)'testname . ',testname
     contains
     subroutine parse(name)
     !x! PUT EVERYTHING TO DO WITH COMMAND PARSING HERE FOR CLARITY
     use M_CLI2, only : set_args, get_args, get_args_fixed_length
     use M_CLI2, only : get_subcommand, set_mode
     character(len=*)              :: name    ! the subcommand name
     character(len=:),allocatable  :: help_text(:), version_text(:)
        call set_mode('response_file')
     ! define version text
        version_text=[character(len=80) :: &
           '@(#)PROGRAM:     demo_get_subcommand            >', &
           '@(#)DESCRIPTION: My demo program  >', &
           '@(#)VERSION:     1.0 20200715     >', &
           '@(#)AUTHOR:      me, myself, and I>', &
           '@(#)LICENSE:     Public Domain    >', &
           '' ]
         ! general help for "demo_get_subcommand --help"
         help_text=[character(len=80) :: &
          ' allowed subcommands are          ', &
          '   * run  -l -L --title -x -y -z  ', &
          '   * test -l -L --title           ', &
          '' ]
        ! find the subcommand name by looking for first word on command
        ! not starting with dash
        name = get_subcommand()
        select case(name)
        case('run')
         help_text=[character(len=80) :: &
          '                                  ', &
          ' Help for subcommand "run"        ', &
          '                                  ', &
          '' ]
         call set_args( &
         & '-x 1 -y 2 -z 3 --title "my title" -l F -L F',&
         & help_text,version_text)
         call get_args('x',x)
         call get_args('y',y)
         call get_args('z',z)
         call get_args_fixed_length('title',title)
         call get_args('l',l)
         call get_args('L',l_)
        case('test')
         help_text=[character(len=80) :: &
          '                                  ', &
          ' Help for subcommand "test"       ', &
          '                                  ', &
          '' ]
         call set_args(&
         & '--title "my title" -l F -L F --testname "Test"',&
         & help_text,version_text)
         call get_args_fixed_length('title',title)
         call get_args('l',l)
         call get_args('L',l_)
         call get_args_fixed_length('testname',testname)
        case default
         ! process help and version
         call set_args(' ',help_text,version_text)
         write(*,'(*(a))')'unknown or missing subcommand [',trim(name),']'
         write(*,'(a)')[character(len=80) ::  &
         ' allowed subcommands are          ', &
         '   * run  -l -L -title -x -y -z   ', &
         '   * test -l -L -title            ', &
         '' ]
         stop
        end select
     end subroutine parse
     end program demo_get_subcommand

program test_syntax
!> @(#) unnamed to numbers
!! The default for inums, rnums, ... is to convert all unnamed argument values in "unnamed"
use, intrinsic :: iso_fortran_env, only : stderr=>ERROR_UNIT, stdin=>INPUT_UNIT, stdout=>OUTPUT_UNIT
use M_CLI2,  only : set_args, sget, sgets, iget, igets, rget, rgets, dget, dgets, lget, lgets
implicit none
character(len=*),parameter :: it='(1x,*(g0,1x))'
character(len=:),allocatable :: whichone

   call set_args(' --type run -i 1 --ints:I 1,2,3 -s " " --strings " " -r 0.0 --reals:R 11.1,22.2,33.3')
   whichone=sget('type')
   select case(whichone)
   case('one')   
    call testit(whichone//' i',iget('i')==1)
    call testit(whichone//' ints',all(igets('ints')==[1,2,3]))
    call testit(whichone//' r',rget('r')==0.0)
    call testit(whichone//' reals',all(rgets('reals')==[11.1,22.2,33.3]))
    call testit(whichone//' s',sget('s')==" ")
    call testit(whichone//' strings',all(sgets('strings')==[" "]))
   case('two')   
    call testit(whichone//' ints',all(igets('ints')==[0,1,2,20,30,40,300,400,1000,2000]))
   case('three')   
    write(*,it)'three:size=',size(sgets('strings'))
    write(*,'(*("[",a,"]":,1x))')sgets('strings')
   case('run')
      print *,'test_syntax: syntax mode'
      call runit('--type one -u')
      call runit('--type one ')
      call runit('--type two -I 0,1,2 --ints=20:30:40 --ints 300,400 -I=1000,2000')
      call runit('--type three')
   case default
      print it,'unknown type'
   end select
contains

subroutine testit(string,test)
character(len=*),intent(in) :: string
logical,intent(in) :: test

   if(test)then
      print it,':syntax:',string,'passed'
   else
      print it,':syntax:',string,'failed'
      stop 1
   endif

end subroutine testit

subroutine runit(string)
character(len=*),intent(in) :: string
character(len=4096) :: cmd
   call get_command_argument(0,cmd)
   write(stdout,*)'RUN:',trim(cmd)//' '//string
   call execute_command_line(trim(cmd)//' '//string)
end subroutine runit

end program test_syntax

      program demo_set_args
      use M_CLI2,  only : filenames=>unnamed, set_args, get_args
      use M_CLI2,  only : get_args_fixed_size
      implicit none
      integer                      :: i
      ! DEFINE ARGS
      real                         :: x, y, z
      real                         :: p(3)
      character(len=:),allocatable :: title
      logical                      :: l, lbig
      integer,allocatable          :: ints(:)
      !
      !  DEFINE COMMAND (TO SET INITIAL VALUES AND ALLOWED KEYWORDS)
      !  AND READ COMMAND LINE
      call set_args(' &
         ! reals
         & -x 1 -y 2.3 -z 3.4e2 &
         ! integer array
         & -p -1,-2,-3 &
         ! always double-quote strings
         & --title "my title" &
         ! string should be a single character at a minimum
         & --label " ", &
         ! set all logical values to F
         & -l F -L F &
         ! set allocatable size to zero if you like by using a delimiter
         & --ints , &
         & ')
      ! ASSIGN VALUES TO ELEMENTS
      !     SCALARS
      call get_args('x',x)
      call get_args('y',y)
      call get_args('z',z)
      call get_args('l',l)
      call get_args('L',lbig)
      call get_args('ints',ints)      ! ALLOCATABLE ARRAY
      call get_args('title',title)    ! ALLOCATABLE STRING
      call get_args_fixed_size('p',p) ! NON-ALLOCATABLE ARRAY
      ! USE VALUES
      write(*,*)'x=',x
      write(*,*)'y=',y
      write(*,*)'z=',z
      write(*,*)'p=',p
      write(*,*)'title=',title
      write(*,*)'ints=',ints
      write(*,*)'l=',l
      write(*,*)'L=',lbig
      ! UNNAMED VALUES
      if(size(filenames) > 0)then
         write(*,'(i6.6,3a)')(i,'[',filenames(i),']',i=1,size(filenames))
      endif
      end program demo_set_args

program demo18
!!  @(#) using the convenience functions
use M_CLI2, only : set_args, set_mode, get_args
implicit none
logical :: o,x,t,ox,xo,x_up,o_up,a,b

   print *,'demo18: using the bundling option'

   call set_mode('strict')
   call set_mode('ignorecase')

   call set_args('-x F -o F -X F -O F -t F --ox F -xo F -longa:a F -longb:b')
   call get_args('x',x,'o',o,'t',t,'xo',xo,'ox',ox,'X',x_up,'O',o_up)
   call get_args('longa',a,'longb',b)
!! USE THE VALUES IN YOUR PROGRAM.
   write(*, '(*(g0:,1x))')'x=',x, 'o=',o, 't=',t 
   write(*, '(*(g0:,1x))')'ox=',ox, 'xo=',xo
   write(*, '(*(g0:,1x))')'O=',o_up, 'X=',x_up
   write(*, '(*(g0:,1x))')'longa=',a, 'longb=',b

end program demo18

program demo3
!!  @(#) example of **basic** use using just the bare essentials
use M_CLI2,  only : set_args, get_args
implicit none
integer                      :: x, y
logical                      :: l
real                         :: size
character(len=:),allocatable :: title

   print *,'demo3: just the bare essentials'

   ! define the command, set default values and read the command line
   call set_args('-x 1 -y 10 --size 12.34567  -l F --title "my title"')

   ! get the values
   call get_args('x',x, 'y',y,'l',l, 'size',size) ! all the non-allocatables
   call get_args('title',title) ! do allocatables one at a time

   ! Done. All variables set and of the requested type
   write(*,'(*("[",g0,"]":,1x))')x,y,size,l,title

end program demo3

program demo7
!! @(#) controlling array delimiter characters
use M_CLI2,  only : set_args, get_args, get_args_fixed_size, get_args_fixed_length
implicit none
integer,parameter              :: dp=kind(0.0d0)

character(len=20),allocatable  :: flen(:)   ! allocatable array with fixed length
character(len=4)               :: fixed(2)  ! fixed-size array wih fixed length

integer,allocatable            :: integers(:)
real,allocatable               :: reals(:)
real(kind=dp),allocatable      :: doubles(:)
real(kind=dp),allocatable      :: normal(:)
complex,allocatable            :: complexs(:)
character(len=:),allocatable   :: characters(:)  ! allocatable array with allocatable length

   print *,'demo7: controlling array delimiter characters'

   ! ARRAY DELIMITERS
   !
   ! NOTE SET_ARGS(3f) DELIMITERS MUST MATCH WHAT IS USED IN GET_ARGS*(3f)
   !
   call set_args('-flen A,B,C -fixed X,Y --integers z --reals 111/222/333 -normal , --doubles | --complexs 0!0 --characters @')
   call get_args('integers',integers,delimiters='abcdefghijklmnopqrstuvwxyz')
   call get_args('reals',reals,delimiters='/')
   call get_args('doubles',doubles,delimiters='|')
   call get_args('complexs',complexs,delimiters='!')
   call get_args('normal',normal)
   call get_args('characters',characters,delimiters='@')

   call get_args_fixed_length('flen',flen)
   call get_args_fixed_size('fixed',fixed) ! fixed length and fixed size array

   write(*,'(g0,1x,a,*("[",g0,"]":,1x))')size(flen),'flen=',flen
   write(*,'(g0,1x,a,*("[",g0,"]":,1x))')size(characters),'characters=',characters
   write(*,'(g0,1x,a,*("[",g0,"]":,1x))')size(integers),'integers=',integers
   write(*,'(g0,1x,a,*("[",g0,"]":,1x))')size(reals),'reals=',reals
   write(*,'(g0,1x,a,*("[",g0,"]":,1x))')size(doubles),'doubles=',doubles
   write(*,'(g0,1x,a,*("[",g0,"]":,1x))')size(complexs),'complexs=',complexs
   write(*,'(g0,1x,a,*("[",g0,"]":,1x))')size(normal),'normal=',normal
   write(*,'(g0,1x,a,*("[",g0,"]":,1x))')size(fixed),'fixed=',fixed
end program demo7
!==================================================================================================================================
! EXAMPLE CALL
! demo7 -integers 1a2b3c4d5e6 -reals 1/2/3/4 -doubles '40|50|60' -complexs '2!3!4!5' --characters aaa@BBBB@c,d,e
! EXPECTED OUTPUT
! 3 characters=[aaa  ] [BBBB ] [c,d,e]
! 6 integers=[1] [2] [3] [4] [5] [6]
! 4 reals=[1.00000000] [2.00000000] [3.00000000] [4.00000000]
! 3 doubles=[40.000000000000000] [50.000000000000000] [60.000000000000000]
! 0 normal=[
! 2 complexs=[2.00000000] [3.00000000] [4.00000000] [5.00000000]
! 2 fixed=[X   ] [Y   ]
!==================================================================================================================================

      program demo_get_args_fixed_size
      use M_CLI2,  only : set_args, get_args_fixed_size
      implicit none
      integer,parameter   :: dp=kind(0.0d0)
      ! DEFINE ARGS
      real                :: x(2)
      real(kind=dp)       :: y(2)
      integer             :: p(3)
      character(len=80)   :: title(1)
      logical             :: l(4), lbig(4)
      complex             :: cmp(2)
      ! DEFINE AND PARSE (TO SET INITIAL VALUES) COMMAND LINE
      !   o only quote strings
      !   o set all logical values to F or T.
      call set_args(' &
         & -x 10.0,20.0 &
         & -y 11.0,22.0 &
         & -p -1,-2,-3 &
         & --title "my title" &
         & -l F,T,F,T -L T,F,T,F  &
         & --cmp 111,222.0,333.0e0,4444 &
         & ')
      ! ASSIGN VALUES TO ELEMENTS
         call get_args_fixed_size('x',x)
         call get_args_fixed_size('y',y)
         call get_args_fixed_size('p',p)
         call get_args_fixed_size('title',title)
         call get_args_fixed_size('l',l)
         call get_args_fixed_size('L',lbig)
         call get_args_fixed_size('cmp',cmp)
      ! USE VALUES
         write(*,*)'x=',x
         write(*,*)'p=',p
         write(*,*)'title=',title
         write(*,*)'l=',l
         write(*,*)'L=',lbig
         write(*,*)'cmp=',cmp
      end program demo_get_args_fixed_size

program demo8
!! @(#) Sometimes you can put multiple values on getargs(3f)
use M_CLI2,  only : set_args, get_args
implicit none
integer           :: x, y
logical           :: l
real              :: size
character(len=80) :: title
character(len=*),parameter :: pairs='(1("[",g0,"=",g0,"]":,1x))'

   print *,'demo8: Sometimes you can put multiple values on getargs(3f)'

   ! DEFINE COMMAND AND PARSE COMMAND LINE
   ! set all values, double-quote strings
   call set_args('-x 1 -y 10 --size 12.34567 -l F --title "my title"' )

   ! GET THE VALUES
   ! only fixed scalar values (including only character variables that
   ! are fixed length) may be combined in one GET_ARGS(3f) call
   call get_args('x',x, 'y',y, 'l',l, 'size',size, 'title',title)

   ! USE THE VALUES
   write(*,fmt=pairs)'X',x,'Y',y,'size',size,'L',l,'TITLE',title

end program demo8

program demo16
!> @(#) unnamed to numbers
!! The default for inums, rnums, ... is to convert all unnamed argument values in "unnamed"
use, intrinsic :: iso_fortran_env, only : stderr=>ERROR_UNIT, stdin=>INPUT_UNIT, stdout=>OUTPUT_UNIT
use M_CLI2,  only : set_args, sget, igets, rgets, dgets
implicit none
character(len=*),parameter :: all='(1x,*(g0,1x))'
   call set_args('-type test')
   select case(sget('type'))
   case('i','int','integer');  print all, igets()
   case('r','real');           print all, rgets()
   case('d','double');         print all, dgets()
   case('test')
      print *,'demo16: convert all arguments to numerics'
      ! positive BOZ whole number values are allowed
      ! e-format is allowed, ints(3f) truncates
      call runit('-type i 10 b10 o10 z10 14.1 14.5 14.999 45.67e3')
      call runit('-type r 10 b10 o10 z10 14.1 14.5 14.999 45.67e3')
      call runit('-type d 10 b10 o10 z10 14.1 14.5 14.999 45.67e3')
   case default
      print all,'unknown type'
   end select
contains
subroutine runit(string)
character(len=*),intent(in) :: string
character(len=4096) :: cmd
   call get_command_argument(0,cmd)
   write(stdout,*)'RUN:',trim(cmd)//' '//string
   call execute_command_line(trim(cmd)//' '//string)
end subroutine runit
end program demo16

program demo17
!!  @(#) using the unnamed parameters as filenames
!!  For example, this should list the files in the current directory
!!
!!     demo17 *
!!
!!  Also demonstrates setting --help and --version text.
!!
!!     demo17 --help
!!     demo17 --version
!!     demo17 --usage
!!
use M_CLI2,  only : get_args
use M_CLI2,  only : sget, lget, iget, rget, dget, cget
use M_CLI2,  only : sgets, lgets, igets, rgets, dgets, cgets
use M_CLI2,  only : filenames=>unnamed
implicit none
type(character(len=*)),parameter    :: all='(*(g0))'
type(integer)                       :: indx

!! argument values to set
type(integer)                       :: i,j,k
type(real)                          :: x,y,z
type(character(len=:)),allocatable  :: title
type(logical)                       :: l,m,n
type(character(len=:)),allocatable  :: fnames(:)

   print all,'demo17: using the unnamed parameters as filenames'
   print all,'example: demo17 -x 100  * '

   call parse() !! Define and parse command line
   !! Get argument values 
   call get_args('x',x,'y',y,'z',z)
   call get_args('i',i,'j',j,'k',k)
   call get_args('l',l,'m',m,'n',n)
   title=sget('title')

   !! All done cracking the command line use the values in your program.
   print all,'x=',x ,' y=',y ,' z=',z
   print all,'i=',i ,' j=',j ,' k=',k
   print all,'l=',l ,' m=',m ,' n=',n
   print all,'title=',title

   !! The optional unnamed values on the command line are
   !! accumulated in the character array "UNNAMED" which was 
   !! renamed to "FILENAMES" on the use statement
   if(allocated(filenames))then
      if(size(filenames) > 0)then
         print all,'files:'
         print '(i6.6,1x,3a)',(indx,'[',filenames(indx),']',indx=1,size(filenames))
      endif
   endif

   ! alternate method, additionally can be used when desired result is numeric
   ! by using igets(3f), rgets(3f), ... instead of sgets(3f).

   fnames=sgets() ! also gets all the unnamed arguments
   if(size(fnames) > 0)then
      print all,'files:'
      print '(i6.6,1x,3a)',(indx,'[',fnames(indx),']',indx=1,size(fnames))
   endif

contains
subroutine parse()
!! Put everything to do with command parsing here 
!!
use M_CLI2,  only : set_args, set_mode
call set_mode([character(len=20) :: 'strict','ignorecase'])
! a single call to set_args can define the options and their defaults, set help
! text and version information, and crack command line.
call set_args(&
!! DEFINE COMMAND OPTIONS AND DEFAULT VALUES
' &
 -i 1 -j 2 -k 3     &
 -l F -m F -n F     &
 -x 1 -y 2 -z 3     &
 --title "my title" &
!! ## HELP TEXT ##
', [character(len=80) :: &
!12345678901234567890123456789012345678901234567890123456789012345678901234567890
'NAME                                                                            ', &
'   myprogram(1) - make all things possible                                      ', &
'SYNOPSIS                                                                        ', &
'   myprogram [-i NNN] [-j NNN] [-k NNN] [-l] [-m] [-n] ]                        ', &
'             [-x NNN.mm] [-y NNN.mm] [-z NNN.mm] [FILENAMES]                    ', &
'DESCRIPTION                                                                     ', &
'   myprogram(1) makes all things possible given stuff.                          ', &
'OPTIONS                                                                         ', &
'   -i,-j,-k   some integer values                                               ', &
'   -l,-m,-n   some logical values                                               ', &
'   -x,-y,-z   some real values                                                  ', &
'   --title    a string argument                                                 ', &
'   FILENAMES  any additional strings                                            ', &
'EXAMPLE                                                                         ', &
'   Typical usage:                                                               ', &
'                                                                                ', &
'     demo17 *.*                                                                 ', &
'                                                                                ', &
'                                                                                ', &
!! ## VERSION TEXT (with optional @(#) prefix for what(1) command) ##
'' ], [character(len=80) :: &
'@(#)PROGRAM:     demo17           >', &
'@(#)DESCRIPTION: My demo program  >', &
'@(#)VERSION:     1.0 20200115     >', &
'@(#)AUTHOR:      me, myself, and I>', &
'@(#)LICENSE:     Public Domain    >', &
'' ])

end subroutine parse

end program demo17

program demo4
!!  @(#) _COMPLEX_ type values
use M_CLI2,  only : set_args, get_args, get_args_fixed_size
implicit none
complex                      :: x, y, z   ! scalars
complex,allocatable          :: aarr(:)   ! allocatable array
complex                      :: three(3)  ! fixed-size array

! formats to pretty-print a complex value and small complex vector
character(len=*),parameter   :: form='("(",g0,",",g0,"i)":,1x)'
character(len=*),parameter   :: forms='(*("(",g0,",",g0,"i)":,",",1x))'

   print *,'demo4: COMPLEX argument example'

   ! COMPLEX VALUES
   !
   !  o parenthesis are optional and are ignored in complex values.
   !
   !  o base#value is acceptable for base 2 to 32 for whole numbers,
   !    which is why "i" is not allowed as a suffix on imaginary values
   !    (because some bases include "i" as a digit).
   !
   !  o normally arrays are allocatable. if a fixed size array is used
   !    call get_args_fixed_size(3f) and all the values must be
   !    specified. This is useful when you have something that requires
   !    a specific number of values. Perhaps a point in space must always
   !    have three values, for example.
   !
   !  o default delimiters are whitespace, comma and colon. Note that
   !    whitespace delimiters should not be used in the definition,
   !    but are OK on command input if the entire parameter value is
   !    quoted. Using space delimiters in the prototype definition is
   !    not supported (but works) and requires that the value be quoted
   !    on input in common shells. Adjacent delimiters are treated as
   !    a single delimiter.
   !
   call set_args('-x (1,2) -y 10,20 -z (2#111,16#-AB) -three 1,2,3,4,5,6 -aarr 111::222,333::444')
   call get_args('x',x)
   call get_args('y',y)
   call get_args('z',z)
   call get_args_fixed_size('three',three)
   call get_args('aarr',aarr)
   write(*,form)x,y,z, x+y+z
   write(*,forms)three
   write(*,forms)aarr
end program demo4
!
! expected output:
!
! (1.00000000,2.00000000i)
! (10.0000000,20.0000000i)
! (7.00000000,-171.000000i)
! (18.0000000,-149.000000i)
! (1.00000000,2.00000000i), (3.00000000,4.00000000i), (5.00000000,6.00000000i)
! (111.000000,222.000000i), (333.000000,444.000000i)

     program demo_specified
     use, intrinsic :: iso_fortran_env, only : &
     & stderr=>ERROR_UNIT, stdin=>INPUT_UNIT, stdout=>OUTPUT_UNIT
     use M_CLI2,  only : set_args, igets, rgets, specified, sget, lget
     implicit none

     ! Define args
     integer,allocatable  :: ints(:)
     real,allocatable     :: floats(:)
     logical              :: flag
     character(len=:),allocatable :: color
     character(len=:),allocatable :: list(:)
     integer :: i

      call set_args('&
         & --color:c "red"       &
         & --flag:f F            &
         & --ints:i 1,10,11      &
         & --floats:T 12.3, 4.56 &
         & ')
      ints=igets('ints')
      floats=rgets('floats')
      flag=lget('flag')
      color=sget('color')

      write(*,*)'color=',color
      write(*,*)'flag=',flag
      write(*,*)'ints=',ints
      write(*,*)'floats=',floats

      write(*,*)'was -flag specified?',specified('flag')

      ! elemental
      write(*,*)specified(['floats','ints  '])

      ! If you want to know if groups of parameters were specified use
      ! ANY(3f) and ALL(3f)
      write(*,*)'ANY:',any(specified(['floats','ints  ']))
      write(*,*)'ALL:',all(specified(['floats','ints  ']))

      ! For mutually exclusive
      if (all(specified(['floats','ints  '])))then
          write(*,*)'You specified both names --ints and --floats'
      endif

      ! For required parameter
      if (.not.any(specified(['floats','ints  '])))then
          write(*,*)'You must specify --ints or --floats'
      endif

     ! check if all values are in range from 10 to 30 and even
     write(*,*)'are all numbers good?',all([ints >= 10,ints <= 30,(ints/2)*2 == ints])

     ! perhaps you want to check one value at a time
     do i=1,size(ints)
        write(*,*)ints(i),[ints(i) >= 10,ints(i) <= 30,(ints(i)/2)*2 == ints(i)]
        if(all([ints(i) >= 10,ints(i) <= 30,(ints(i)/2)*2 == ints(i)]) )then
           write(*,*)ints(i),'is an even number from 10 to 30 inclusive'
        else
           write(*,*)ints(i),'is not an even number from 10 to 30 inclusive'
        endif
     enddo

     list = [character(len=10) :: 'red','white','blue']
     if( any(color == list) )then
        write(*,*)color,'matches a value in the list'
     else
        write(*,*)color,'not in the list'
     endif

     if(size(ints).eq.3)then
        write(*,*)'ints(:) has expected number of values'
     else
        write(*,*)'ints(:) does not have expected number of values'
     endif

     end program demo_specified

#!/bin/bash

(
exec 2>&1
make clean
make ifort
../example/demo1 -x 1111111 -y 2222222 -u -z 33333.9 -lL -u -v 
../example/demo1 -usage 
make run
)>x.if

(
exec 2>&1
make clean
make nvfortran
../example/demo1 -x 1111111 -y 2222222 -u -z 33333.9 -lL -u -v 
../example/demo1 -usage 
make run 
) >x.nf

(
exec 2>&1
make clean
make gfortran
../example/demo1 -x 1111111 -y 2222222 -u -z 33333.9 -lL -u -v 
../example/demo1 -usage 
make run 
) >x.gf

make clean

---
src_dir: src
         example
         test
	 docs/images
output_dir: docs/fpm-ford
project: M_CLI2
summary: command line parsing
project_github: https://github.com/urbanjost/M_CLI2
project_download:
author: John S. Urban
author_email: urbanjost@comcast.net
github: https://github.com/urbanjost/M_CLI2
media_dir: docs/images
exclude_dir: archive
             FODDER
display: public
         protected
source: true
proc_internals: true
sort: permission-alpha
favicon: docs/images/favicon.ico
print_creation_date: true
extra_mods: iso_fortran_env:https://gcc.gnu.org/onlinedocs/gfortran/ISO_005fFORTRAN_005fENV.html
            tomlf:https://toml-f.github.io/toml-f
creation_date: %Y-%m-%d %H:%M %z
md_extensions: markdown.extensions.toc
               markdown.extensions.smarty
---
{!README.md!}
---

## STATUS

On each push or pull request this repository automatically runs "fpm
test" to run its unit tests on Ubuntu(gfortran,ifort), MacOS(gfortran),
and MSWindows(gfortran) using github actions.

The results are able to be viewed using the **Actions** button at the
top of the github page for the repository, or can be linked to in site
documents:

+ [![Build FORD(1) docs](https://github.com/urbanjost/M_CLI2/actions/workflows/deploy_api_docs.yml/badge.svg)](https://github.com/urbanjost/M_CLI2/actions/workflows/deploy_api_docs.yml)
+ [![run fpm test on ubuntu with intel](https://github.com/urbanjost/M_CLI2/actions/workflows/test_intel_ubuntu.yml/badge.svg)](https://github.com/urbanjost/M_CLI2/actions/workflows/test_intel_ubuntu.yml)
+ [![run fpm test on ubuntu with gfortran](https://github.com/urbanjost/M_CLI2/actions/workflows/test_gfortran_ubuntu.yml/badge.svg)](https://github.com/urbanjost/M_CLI2/actions/workflows/test_gfortran_ubuntu.yml)
+ [![run fpm test on macos with gfortran](https://github.com/urbanjost/M_CLI2/actions/workflows/test_gfortran_macos.yml/badge.svg)](https://github.com/urbanjost/M_CLI2/actions/workflows/test_gfortran_macos.yml)
+ [![run fpm test on windows with gfortran](https://github.com/urbanjost/M_CLI2/actions/workflows/test_gfortran_windows.yml/badge.svg)](https://github.com/urbanjost/M_CLI2/actions/workflows/test_gfortran_windows.yml)
+ [![run fpm test on windows with mingw64 ](https://github.com/urbanjost/M_CLI2/actions/workflows/test_gfortran_mingw64_windows.yml/badge.svg)](https://github.com/urbanjost/M_CLI2/actions/workflows/test_gfortran_mingw64_windows.yml)
+ [![run fpm test on windows with msys gfortran](https://github.com/urbanjost/M_CLI2/actions/workflows/test_gfortran_msys_windows.yml/badge.svg)](https://github.com/urbanjost/M_CLI2/actions/workflows/test_gfortran_msys_windows.yml)
